import objectdraw.*;
import java.awt.*;
import javax.swing.JSlider;

/*
 * 
 * Example FallingSnow: the snowflakes that fall, this time with
 * x speeds controlled by a slider that was passed in and saved.
 *
 * Jim Teresco, Siena College, CSIS 120, Spring 2011
 * The College of Saint Rose, Fall 2013, Fall 2014
 * Based on example from CSCI 134, Williams College
 *
 * $Id: FallingSnow.java 2452 2014-10-13 15:59:20Z terescoj $
 */

public class FallingSnow extends ActiveObject {

    // delay between snow motions
    private static final int DELAY_TIME = 33;

    private DrawingCanvas canvas;

    // speed of fall
    private double ySpeed;

    // the snowflake
    private VisibleImage snow;

    // the wind
    private JSlider wind;
    
    // initialize the instance variables and start the active object
    public FallingSnow(DrawingCanvas aCanvas, Image aSnowPic, JSlider w,
                       double x, double aSpeed) {
        canvas = aCanvas;
        ySpeed = aSpeed;
        wind = w;

        snow = new VisibleImage(aSnowPic, 0, 0, canvas);
        snow.move(x, - snow.getHeight());

        start();
    }

    public void run() {

        // as long as the snow is still on the screen
        // move it and pause
        while (snow.getY() < canvas.getHeight()) {
            pause(DELAY_TIME);
            // get the x speed from the JSlider
            snow.move(wind.getValue(),ySpeed);
        }

        snow.removeFromCanvas();
    }

}